//+------------------------------------------------------------------+
//|                                                     kmonosci.mq4 |
//|                                                   Kelch Monteiro |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Kelch Monteiro"
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Yellow

extern int ma1period=7;
extern int ma2period=7;
extern double ma3period=7.0;
extern int bbandsperiod=200;

//--- buffers
double ExtMapBuffer1[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
      
   IndicatorShortName ("kmonosci ("+ma1period+","+ma2period+","+ma3period+")");
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
   
   for(i=limit; i>=0; i--)
   { 
        double bbands = iBands(NULL,0,bbandsperiod,2,0,1,1,i);
        double ma1 = iMA(NULL,5,ma1period,0,1,2,i);
        double ma2 = iMA(NULL,5,ma2period,0,1,3,i);
        double ma3 = iMA(NULL,5,ma3period,0,1,4,i);
        double kmonosci = (ma3-(ma1-ma2/2)*100);
        if (kmonosci==0){kmonosci=1;}
        double kmont = (bbands);
        if (kmont!=0)
            double enter = kmonosci/kmont*100;
        else       enter = 0;  
        ExtMapBuffer1[i]= enter;
   }
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+